diff --git a/src/bytecode.c b/src/bytecode.c
index 74a94859aba..8f30fa55829 100644
--- a/src/bytecode.c
+++ b/src/bytecode.c
@@ -382,6 +382,9 @@ #define BC_STACK_SIZE (512 * 1024 * sizeof (Lisp_Object))
   const unsigned char *saved_pc;    /* previous program counter */
 
   Lisp_Object fun;                  /* current function object */
+#ifdef ENABLE_CHECKING
+  specpdl_ref entry_specpdl_depth;  /* specpdl depth at function entry */
+#endif
 
   Lisp_Object next_stack[];	    /* data stack of next frame */
 };
@@ -484,10 +487,6 @@ exec_byte_code (Lisp_Object fun, ptrdiff_t args_template,
  setup_frame: ;
   eassert (!STRING_MULTIBYTE (bytestr));
   eassert (string_immovable_p (bytestr));
-  /* FIXME: in debug mode (!NDEBUG, BYTE_CODE_SAFE or enabled checking),
-     save the specpdl index on function entry and check that it is the same
-     when returning, to detect unwind imbalances.  This would require adding
-     a field to the frame header.  */
 
   Lisp_Object vector = AREF (fun, COMPILED_CONSTANTS);
   Lisp_Object maxdepth = AREF (fun, COMPILED_STACK_DEPTH);
@@ -511,6 +510,9 @@ exec_byte_code (Lisp_Object fun, ptrdiff_t args_template,
   fp->saved_pc = pc;
   fp->saved_fp = bc->fp;
   bc->fp = fp;
+#ifdef ENABLE_CHECKING
+  fp->entry_specpdl_depth = SPECPDL_INDEX ();
+#endif
 
   top = frame_base - 1;
   unsigned char const *bytestr_data = SDATA (bytestr);
@@ -878,6 +880,8 @@ #define DEFINE(name, value) [name] = &&insn_ ## name,
 
 	CASE (Breturn):
 	  {
+	    eassert (specpdl_ref_eq (bc->fp->entry_specpdl_depth,
+				     SPECPDL_INDEX ()));
 	    Lisp_Object *saved_top = bc->fp->saved_top;
 	    if (saved_top)
 	      {
